<template>
  <ObForm
    :form-model="formModel"
    :form-data="formData"
    @submit="onSubmit"
    :ok-text="okText"
    :dropdown-menu="dropdownMenu"
    data-qa="tenderBuyerAddForm"
  >
    <div v-if="categories.length" class="ob-modal-container">
      <div class="modal-body">
        <div
          v-for="category in categories"
          :key="category.uuid"
          class="row"
        >
          <div class="col-xs-12">
            <SubTitle>{{ category.title }}</SubTitle>

            <div
              v-for="field in category.items"
              :key="field.uuid"
              class="row"
            >
              <div class="col-xs-12">
                <ObInput
                  v-if="field.valueType === 'TEXT'"
                  :label="field.title"
                  placeholder="Введите"
                  v-model="formData[field.uuid]"
                  :required="field.isRequired"
                  :data-uuid="field.uuid"
                  :data-qa="getFieldId(field)"
                />

                <ObSelect
                  v-else-if="field.valueType.startsWith('CHECKLIST')"
                  :label="field.title"
                  placeholder="Выберите"
                  v-model="formData[field.uuid]"
                  :is-clearable="!field.isRequired"
                  :required="field.isRequired"
                  :items="field.options"
                  :is-dropdown="field.valueType === 'CHECKLIST_LIST'"
                  :data-uuid="field.uuid"
                  :data-qa="getFieldId(field)"
                />

                <ObInput
                  v-else-if="field.valueType === 'INTEGER'"
                  :label="field.title"
                  :placeholder="field.title"
                  v-model="formData[field.uuid]"
                  :required="field.isRequired"
                  type="number:strict"
                  :data-uuid="field.uuid"
                  :data-qa="getFieldId(field)"
                  @input="checkLength(field.uuid, $event)"
                />

                <ObInput
                  v-else-if="field.valueType === 'FLOAT'"
                  :label="field.title"
                  :placeholder="field.title"
                  v-model="formData[field.uuid]"
                  :required="field.isRequired"
                  :data-uuid="field.uuid"
                  :data-qa="getFieldId(field)"
                  :is-convert-money="false"
                  type="money:2"
                  @input="checkLength(field.uuid, $event)"
                />

                <div
                  v-else-if="field.valueType === 'BOOLEAN'"
                  class="row"
                >
                  <div class="col-xs-12">
                    {{ field.title }}
                  </div>

                  <div class="col-xs-12">
                    <div class="row">
                      <div class="col-xs-12">
                        <div class="form-row">
                          <ObRadio
                            label="Да"
                            :value-input="true"
                            v-model="formData[field.uuid]"
                            class="radio-first"
                            :data-uuid="field.uuid"
                            :data-qa="`${getFieldId(field)}_yes`"
                          />

                          <ObRadio
                            label="Нет"
                            :value-input="false"
                            v-model="formData[field.uuid]"
                            :data-uuid="field.uuid"
                            :data-qa="`${getFieldId(field)}_no`"
                          />
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </ObForm>
</template>

<script>
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
  import { required } from 'vuelidate/lib/validators'
  import api from '@/api'
  import { mapGetters } from 'vuex'

  import ObForm from 'common-components/src/obComponents/obForm'
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObSelect from 'common-components/src/obComponents/obSelect'
  import ObRadio from 'common-components/src/obComponents/obRadio'

  import SubTitle from '../../components/SubTitle'

  export default {
    name: 'addEdit',
    components: {
      ObForm,
      ObInput,
      ObSelect,
      ObRadio,
      SubTitle
    },
    mixins: [
      FormValidationMixin
    ],
    props: {
      columns: {
        type: Array,
        default: () => {}
      },
      okText: {
        type: String,
        default: null
      },
      dropdownMenu: {
        type: Array,
        default: null
      }
    },
    computed: {
      ...mapGetters({
        tenderInfo: 'tenders/tenderInfo'
      }),
      formModel () {
        if (!this.data.headers) {
          return {}
        }

        return this.data.headers.reduce((filtered, field) => {
          if (field.isRequired) {
            filtered[field.uuid] = { validator: { required } }
          } else {
            filtered[field.uuid] = {}
          }

          return filtered
        }, {})
      }
    },
    data () {
      return {
        data: {},
        categories: [],
        fieldsTypes: {}
      }
    },
    methods: {
      getFieldId (field) {
        return `lot_field_${field.code}`
      },
      // Limit maximum length for field to prevent overflow
      checkLength (fieldUuid, value) {
        if (value.length > 9) {
          setTimeout(() => {
            this.formData[fieldUuid] = value.slice(0, 9)
          }, 0)
        }
      },
      onSubmit () {
        this.$emit('save', this.formData, true, this.fieldsTypes)
      },
      async fetchLotForm () {
        try {
          this.data = await api.tenders.getLotForm(this.tenderInfo.requestUuid)

          const categories = []

          this.data.headers.forEach((header) => {
            const index = categories.findIndex((category) => {
              return category.title === header.category.title
            })

            // If items already contains in this category
            if (~index) {
              categories[index].items.push(header)
            } else {
              categories.push({
                ...header.category,
                items: [header]
              })
            }

            // Запоминаем типы ('TEXT', 'INTEGER', ...)
            this.fieldsTypes[header.uuid] = header.valueType
          })

          // Сортировка категорий
          categories.sort((a, b) => {
            return a.pos - b.pos
          })

          // Сортировка полей в категориях
          categories.forEach((category) => {
            category.items.sort((a, b) => {
              return a.pos - b.pos
            })
          })

          this.categories = categories
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка получения формы для создания лота'
          })
        }
      }
    },
    watch: {
      async dataSource () {
        await this.fetchLotForm()
      }
    },
    async mounted () {
      await this.fetchLotForm()
    }
  }
</script>

<style lang="scss" scoped>
  // TODO mobile layout
  @import "~common-components/src/static/css/mixins";

  .ob-modal-container {
    margin-bottom: -20px;
  }

  .form-row {
    display: flex;
  }

  .form-grid {
    display: grid;
    align-items: flex-start;
    grid-auto-flow: column;

    &:not(.no-gap) {
      grid-gap: 20px;
    }
  }

  .form-group {
    margin-bottom: 20px;
    flex-grow: 1;

    &:last-child {
      margin-bottom: 30px;
    }
  }

  .form-select-right {
    min-width: 185px;

    &:not(:first-child) {
      margin-left: 20px;
    }
  }

  .flex-justify {
    display: flex;
    flex-direction: column;
    justify-content: space-between;
  }

  .form-delimiter {
    font-size: 16px;
    margin: 0 5px;
  }

  .form-resources-left,
  .form-resources-right {
    padding-right: 1rem;
    padding-left: 1rem;
  }

  .form-resources-left {
    max-width: 44%;
    flex: 0 0 44%;
  }

  .form-resources-right {
    max-width: 56%;
    flex: 0 0 56%;
  }

  .align-items-center {
    align-items: center;
  }

  .align-items-end {
    align-items: flex-end;
  }

  .w-100 {
    width: 100%;
  }

  .h-100 {
    height: 100%;
  }

  .label {
    @include font-mixin(12px, normal, 400, $color-grey-label, 0.4px);
    margin-bottom: 3px;
  }

  .radio-first {
    margin-right: 27px;
  }

  /deep/ .loading-type .ob-ctrlgroup__item {
    padding: 0 10px;
    min-width: 95px;
  }
</style>
